> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Update

POST https://rest.test.zuora.com/v1/action/update
Content-Type: application/json


Updates the information in one or more objects of the same type. You can specify different types of objects in different update calls, but each specific update call must apply to only one type of object.


### Limitations 

This call has the following limitations:

* A maximum of 50 objects are supported in a single call.
* The Invoice Settlement feature is not supported. This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement.
* The default WSDL version for Actions is 79. To update objects or fields according to a different WSDL version, set the `X-Zuora-WSDL-Version` header. To find out in which WSDL version a particular object or field was introduced, see [Zuora SOAP API Version History](https://knowledgecenter.zuora.com/DC_Developers/G_SOAP_API/Zuora_SOAP_API_Version_History).


### How to use this call? 

You can update an array of one or more zObjects. The fields you should specify can be found in the corresponding "CRUD: Update an *zObject*" operation.
For example, to update one or multiple accounts, use the request fields in the [CRUD: Update an account](https://developer.zuora.com/api-references/older-api/operation/Object_PUTAccount/) operation.

It returns an array of SaveResults sorted in the same order, indicating the success or failure of updating each object. The following information applies to this call:

* You cannot pass in null zObjects.
* You can pass in a maximum of 50 zObjects at a time.
* All objects must be of the same type.
* For each field in each object, you must determine that object's ID. Then populate the fields that you want update with the new information.
* Zuora ignores unrecognized fields in update calls. For example, if an optional field is spelled incorrectly or a field that does not exist is specified, Zuora ignores the field and continues to process the call. No error message is returned for unrecognized fields.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/general-purpose-operations/actions/action-pos-tupdate

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Query parameters

- `rejectUnknownFields` (boolean, optional, default: false) — Specifies whether the call fails if the request body contains unknown fields. With `rejectUnknownFields` set to `true`, Zuora returns a 400 response if the request body contains unknown fields. The body of the 400 response is: ```json { "message": "Error - unrecognised fields" } ``` By default, Zuora ignores unknown fields in the request body.

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `X-Zuora-WSDL-Version` (string, optional, default: 79) — Zuora WSDL version number.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a ProxyActionupdateRequest.

- `objects` (list of zObject_update, required)
- `type` (string, required)

## Response

### 200

OK

- `list of SaveResult`

## Errors

### 401 Unauthorized Error

Unauthorized

- `message` (string, optional) — Error message. If the error message is "Authentication error", ensure that the `Authorization` request header contains valid authentication credentials, then retry the request. See [Authentication](https://developer.zuora.com/docs/guides/authentication/) for more information. If the error message is "Failed to get user info", retry the request.

## Types

### zObject_update

- `Id` (string, required)
- `fieldsToNull` (list of string, optional) — Used to set a list of fields to null.

### SaveResult

- `Errors` (list of ActionsErrorResponse, optional)
- `Id` (string, optional)
- `Success` (boolean, optional)

### ActionsErrorResponse

- `Code` (string, optional)
- `Message` (string, optional)

## Examples

**Request**

```json
{
  "objects": [
    {
      "Id": "8ad09378905a5af201907ca1edb524c2",
      "BillCycleDay": 1
    }
  ],
  "type": "Account"
}
```

**Response**

```json
[
  {
    "Id": "8ad09378905a5af201907ca1edb524c2",
    "Success": true
  }
]
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/action/update"

payload = {
    "objects": [
        {
            "Id": "8ad09378905a5af201907ca1edb524c2",
            "BillCycleDay": 1
        }
    ],
    "type": "Account"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/action/update';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"objects":[{"Id":"8ad09378905a5af201907ca1edb524c2","BillCycleDay":1}],"type":"Account"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/action/update"

	payload := strings.NewReader("{\n  \"objects\": [\n    {\n      \"Id\": \"8ad09378905a5af201907ca1edb524c2\",\n      \"BillCycleDay\": 1\n    }\n  ],\n  \"type\": \"Account\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/action/update")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"objects\": [\n    {\n      \"Id\": \"8ad09378905a5af201907ca1edb524c2\",\n      \"BillCycleDay\": 1\n    }\n  ],\n  \"type\": \"Account\"\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/v1/action/update")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"objects\": [\n    {\n      \"Id\": \"8ad09378905a5af201907ca1edb524c2\",\n      \"BillCycleDay\": 1\n    }\n  ],\n  \"type\": \"Account\"\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/v1/action/update', [
  'body' => '{
  "objects": [
    {
      "Id": "8ad09378905a5af201907ca1edb524c2",
      "BillCycleDay": 1
    }
  ],
  "type": "Account"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/action/update");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"objects\": [\n    {\n      \"Id\": \"8ad09378905a5af201907ca1edb524c2\",\n      \"BillCycleDay\": 1\n    }\n  ],\n  \"type\": \"Account\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "objects": [
    [
      "Id": "8ad09378905a5af201907ca1edb524c2",
      "BillCycleDay": 1
    ]
  ],
  "type": "Account"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/action/update")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```